exercises/nested-resources/config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  root 'web/homes#index'

  # BEGIN
  scope module: :web do
    resources :posts, shallow: :true do
      resources :comments
    end
  end
  # END

  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
end

exercises/nested-resources/app/models/application_record.rb
# frozen_string_literal: true

class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

exercises/nested-resources/app/models/comment.rb
class Comment < ApplicationRecord
  belongs_to :post

  validates :body, presence: true
  validates :body, length: { maximum: 200 }
end

exercises/nested-resources/app/models/post.rb
# frozen_string_literal: true

class Post < ApplicationRecord
  # BEGIN
  has_many :comments, dependent: :destroy
  # END

  validates :title, presence: true
  validates :body, length: { maximum: 500 }
end

exercises/nested-resources/app/controllers/application_controller.rb
# frozen_string_literal: true

class ApplicationController < ActionController::Base
end

exercises/nested-resources/app/controllers/web/comments_controller.rb
module Web
  class CommentsController < ApplicationController
    before_action :set_comment, only: [:edit, :update, :destroy]

    # def new
    # end

    def create
      @post = Post.find(params[:post_id])
      @comment = @post.comments.build(comment_params)
      if @comment.save
        redirect_to @post, notice: 'Comment was successfully created.'
      else
        render 'web/posts/show'
      end
    end

    def edit;end

    def update
      if @comment.update(comment_params)
        redirect_to @comment.post, notice: 'Comment was successfully updated.'
      else
        render :edit, comment: :unprocessable_entity
      end
    end

    def destroy
      post = @comment.post
      @comment.destroy
  
      redirect_to post, notice: 'Comment was successfully destroyed.'
    end
  
    private

    def comment_params
      params.require(:comment).permit(:body)
    end

    def set_comment
      @comment = Comment.find(params[:id])
    end
  end
end

exercises/nested-resources/app/controllers/web/homes_controller.rb
# frozen_string_literal: true

class Web::HomesController < ApplicationController
  def index; end
end

exercises/nested-resources/app/controllers/web/posts_controller.rb
# frozen_string_literal: true
module Web
  class PostsController < ApplicationController
    before_action :set_post, only: %i[show edit update destroy]

    def index
      @posts = Post.all
    end

    def show
      @comment = @post.comments.build
    end

    def new
      @post = Post.new
    end

    def edit; end

    def create
      @post = Post.new(post_params)

      if @post.save
        redirect_to @post, notice: 'Post was successfully created.'
      else
        render :new, status: :unprocessable_entity
      end
    end

    def update
      if @post.update(post_params)
        redirect_to @post, notice: 'Post was successfully updated.'
      else
        render :edit, status: :unprocessable_entity
      end
    end

    def destroy
      @post.destroy

      redirect_to posts_url, notice: 'Post was successfully destroyed.'
    end

    private

    # Use callbacks to share common setup or constraints between actions.
    def set_post
      @post = Post.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def post_params
      params.require(:post).permit(:title, :body)
    end
  end
end

exercises/nested-resources/app/helpers/application_helper.rb
# frozen_string_literal: true

module ApplicationHelper
end

exercises/nested-resources/app/helpers/homes_helper.rb
# frozen_string_literal: true

module HomesHelper
end

exercises/nested-resources/app/views/web/homes/index.html.slim
= content_for :title do
  = 'Home#index'

exercises/nested-resources/app/views/web/posts/_form.html.slim
= simple_form_for(@post) do |f|
  = f.error_notification
  = f.error_notification message: f.object.errors[:base].to_sentence if f.object.errors[:base].present?

  = f.input :title
  = f.input :body

  = f.button :submit, class: 'btn btn-success mt-4 btn-block'

exercises/nested-resources/app/views/web/posts/edit.html.slim
= content_for :title do
  = 'Editing post'

== render 'form'

hr

.d-flex
  = link_to 'Show', @post, class: 'btn btn-outline-primary me-2'
  = link_to 'Back', :back, class: 'btn btn-outline-primary'

exercises/nested-resources/app/views/web/posts/index.html.slim
= content_for :title do
  = 'Posts'

table.table.table-striped.table-hover.mb-5
  thead
    tr
      th{ scope: :col } #
      th{ scope: :col } Title
      th

  tbody
    - @posts.each_with_index do |post, i|
      tr
        th{ scope: :col } = i + 1
        td = post.title
        td.d-flex
          .me-4 = link_to 'Show', post
          .me-4 = link_to 'Edit', edit_post_path(post)
          = link_to 'Destroy', post, data: { confirm: 'Are you sure?' }, method: :delete

= link_to 'New Post', new_post_path, class: 'btn btn-primary'

exercises/nested-resources/app/views/web/posts/new.html.slim
= content_for :title do
  = 'New post'

== render 'form'

hr

= link_to 'Back', :back, class: 'btn btn-outline-primary'

exercises/nested-resources/app/views/web/posts/show.html.slim
= content_for :title do
  = @post.title
p
  strong.me-2 Body:
  = @post.body
/ BEGIN
table.table.table-striped.table-hover.mb-5
  thead
    tr
      th{ scope: :col } Comments
      th
  tbody
    - @post.comments.reject(&:new_record?).each do |comment|
      tr
        td = comment.body
        td.d-flex
          .me-4 = link_to 'Edit', edit_comment_path(comment)
          = link_to 'Destroy', comment, data: { confirm: 'Are you sure?' }, method: :delete

= simple_form_for @comment, url: post_comments_path(@post) do |f|
  = f.error_notification
  = f.error_notification message: f.object.errors[:base].to_sentence if f.object.errors[:base].present?

  = f.input :body, label: false
  = f.submit class: 'btn btn-primary'
/ END
hr

.d-flex
  = link_to 'Edit', edit_post_path(@post), class: 'btn btn-outline-primary me-2'
  = link_to 'Back', :back, class: 'btn btn-outline-primary'